#include "Defs.h"
#include "Crt.h"
#include "Bios.h"
#include "ConCom.h"

#include <avr\pgmspace.h>


BYTE FCommCmpStart;

void CommInit ( void )
{
 FCommCmpStart=0;
}

void CommDeletePacket ( void )
{
 BYTE BIntSave;
 BYTE BWrIndex,
      BRdIndex;
 BYTE BData;

 if (FUartPackSize)
  {
   BIntSave=IntDisable();
   BWrIndex=0; BRdIndex=FUartPackSize; FUartPackSize=0;
   while (BRdIndex<FUartRecvSize)
    {
     BData=FUartRecvBuf[BRdIndex]; BRdIndex++;
     FUartRecvBuf[BWrIndex]=BData; BWrIndex++;
     if ((BData==13)&&(FUartPackSize==0)) FUartPackSize=BWrIndex;
    }
   FUartRecvSize=BWrIndex;
   FCommCmpStart=0;
   IntRestore(BIntSave);
  }
}

void CommSendStrC ( CBytePtr AStr )
{
 BYTE BData;
 BYTE BIndex;

 do
  {
   BData=PgmReadByte(AStr); AStr++;
   if (BData==0) break;
   if (BData==1)
    {
     for (BIndex=FCommCmpStart; BIndex<FUartPackSize; BIndex++)
      {
       BData=FUartRecvBuf[BIndex];
       if ((BData==' ')||(BData==13)) break;
       UartSendByte(BData);
      }
    }
   else
    {
     UartSendByte(BData);
    }
  } while (1);
}

void CommSendStrC13 ( CBytePtr AStr )
{
 CommSendStrC(AStr);
 UartSendByte(13);
}

BYTE CommCmpStrC ( CBytePtr AStr )
{
 BYTE BResult;
 BYTE BDataA,
      BDataB;
 BYTE BIndex;

 BResult=FALSE;
 do
  {
   while (FCommCmpStart<FUartPackSize)
    {
     BDataA=FUartRecvBuf[FCommCmpStart];
     if ((BDataA==13)||(BDataA!=' ')) break;
     FCommCmpStart++;
    }

   BDataA=PgmReadByte(&AStr[0]);

   if (FCommCmpStart==FUartPackSize)
    {
     if (BDataA==0) BResult=TRUE;
     break;
    }

   if (FUartRecvBuf[FCommCmpStart]==13)
    {
     if (BDataA==0) BResult=TRUE;
     break;
    }

   if (BDataA==0) break; // AStr is empty, but FUartRecvBuf is not

   BIndex=0;
   do
    {
     BDataA=LowerCase(FUartRecvBuf[FCommCmpStart+BIndex]);
     BDataB=LowerCase(PgmReadByte(AStr+BIndex));
     BIndex++;
     if (((BDataA==' ')||(BDataA==13))&&(BDataB==0))
      {
       FCommCmpStart+=BIndex;
       BResult=TRUE;
       break;
      }
     if ((BDataA==' ')||(BDataA==13)) break;
     if (BDataB==0) break;
     if (BDataA!=BDataB) break;
    } while (1);

  } while(0);

 return (BResult);
}

void CommSendHex ( BYTE AData )
{
 UartSendByte(Byte4ToHex(AData>>4));
 UartSendByte(Byte4ToHex(AData&0x0F));
}

void CommSendDec ( BYTE AData )
{
 if (AData>=100) { UartSendByte(AData/100+'0'); AData%=100; }
 if (AData>=10) { UartSendByte(AData/10+'0'); AData%=10; }
 UartSendByte(AData+'0');
}

void CommSendBufHex ( BYTE *ABuf, BYTE ALen )
{
 BYTE BIndex;

 for (BIndex=0; BIndex<ALen; BIndex++) CommSendHex(ABuf[BIndex]);
}

BYTE CommDecodeHex ( void )
{
 BYTE BResult;
 BYTE BDataL,
      BDataH;
 BYTE BRdIndex,
      BWrIndex;

 BResult=FALSE;
 do
  {
   while (FCommCmpStart<FUartPackSize)
    {
     BDataL=FUartRecvBuf[FCommCmpStart];
     if ((BDataL==13)||(BDataL!=' ')) break;
     FCommCmpStart++;
    }

   if (FCommCmpStart==FUartPackSize) break;
   if (FUartRecvBuf[FCommCmpStart]==13) break;

   BRdIndex=0; BWrIndex=0; 
   do
    {
     BDataH=LowerCase(FUartRecvBuf[FCommCmpStart+BRdIndex]); BRdIndex++;
     if ((BDataH==' ')||(BDataH==13)) { BResult=TRUE; break; }
     if (HexToByte4(&BDataH)==FALSE) break;
     BDataL=LowerCase(FUartRecvBuf[FCommCmpStart+BRdIndex]); BRdIndex++;
     if ((BDataL==' ')||(BDataL==13)) break;
     if (HexToByte4(&BDataL)==FALSE) break;
     FUartRecvBuf[1+BWrIndex]=(BDataH<<4)+BDataL; BWrIndex++;
    } while (1);

   if (BResult)
    {
     FUartRecvBuf[0]=BWrIndex;
     FCommCmpStart+=BRdIndex;
    }

  } while(0);

 return (BResult);
}

BYTE CommGetDataDH ( DWORD *AData )
{
 BYTE BResult;
 DWORD BDataD;
 BYTE BData;
 BYTE BRdIndex;

 BDataD=0;
 BResult=FALSE;
 do
  {
   while (FCommCmpStart<FUartPackSize)
    {
     BData=FUartRecvBuf[FCommCmpStart];
     if ((BData==13)||(BData!=' ')) break;
     FCommCmpStart++;
    }

   if (FCommCmpStart==FUartPackSize) break;
   if (FUartRecvBuf[FCommCmpStart]==13) break;

   BRdIndex=0;
   do
    {
     BData=LowerCase(FUartRecvBuf[FCommCmpStart+BRdIndex]); BRdIndex++;
     if ((BData==' ')||(BData==13)) { BResult=TRUE; break; }
     if (HexToByte4(&BData)==FALSE) break;
     if (BDataD&0xF0000000) break;
     BDataD=(BDataD<<4)+BData;
    } while (1);

   if (BResult)
    {
     *AData=BDataD;
     FCommCmpStart+=BRdIndex;
    }

  } while(0);

 return (BResult);
}

BYTE CommGetDataD ( DWORD *AData )
{
 BYTE BResult;
 DWORD BDataD;
 BYTE BData;
 BYTE BRdIndex;

 BDataD=0;
 BResult=FALSE;
 do
  {
   while (FCommCmpStart<FUartPackSize)
    {
     BData=FUartRecvBuf[FCommCmpStart];
     if ((BData==13)||(BData!=' ')) break;
     FCommCmpStart++;
    }

   if (FCommCmpStart==FUartPackSize) break;
   if (FUartRecvBuf[FCommCmpStart]==13) break;

   BRdIndex=0;
   do
    {
     BData=LowerCase(FUartRecvBuf[FCommCmpStart+BRdIndex]); BRdIndex++;
     if ((BData==' ')||(BData==13)) { BResult=TRUE; break; }
     if (DecToByte(&BData)==FALSE) break;
     if (BDataD&0xF0000000) break;
     BDataD=(BDataD*10)+BData;
    } while (1);

   if (BResult)
    {
     *AData=BDataD;
     FCommCmpStart+=BRdIndex;
    }

  } while(0);

 return (BResult);
}

