#include <avr\io.h>
#include "Defs.h"

void TimerSet ( BYTE ATimerFlags, BYTE ATimerCmp )
{
 TCCR2=ATimerFlags;
 OCR2=ATimerCmp;
 TCNT2=0;
 TIFR=0x80;
}

void TimerStop ( void )
{
 TCCR2=0;
 OCR2=255;
 TCNT2=0;
 TIFR=0x80;
}

BYTE IntDisable ( void )
{
 BYTE BResult;

 BResult=SREG;
 SREG&=0x7F;

 return (BResult);
}

void IntRestore ( BYTE AIntSave )
{
 SREG=AIntSave;
}

void WDReset ( void )
{
 asm("wdr"::);
}

BYTE EEPromRdDataB ( WORD AAddress )
{
 BYTE BIntSave;
 BYTE BResult;

 while (EECR&0x02) WDReset();

 BIntSave=IntDisable();
 EEARH=AAddress>>8; EEARL=AAddress;
 EECR|=0x01;
 BResult=EEDR;
 IntRestore(BIntSave);

 return BResult;
}

WORD EEPromRdDataW ( WORD AAddress )
{
 WORD BResult;

 BResult= (WORD)EEPromRdDataB(AAddress)|
         ((WORD)EEPromRdDataB(AAddress+1)<<8);

 return BResult;
}

void EEPromWrDataB ( WORD AAddress, BYTE AData )
{
 BYTE BIntSave;

 while (EECR&0x02) WDReset();

 BIntSave=IntDisable();
 EEARH=AAddress>>8; EEARL=AAddress;
 EEDR=AData;
 EECR|=0x04; EECR|=0x02;
 IntRestore(BIntSave);
}

void EEPromWrDataW ( WORD AAddress, WORD AData )
{
 EEPromWrDataB(AAddress,AData);
 EEPromWrDataB(AAddress+1,AData>>8);
}

