#include "Defs.h"
#include "HwDefs.h"

void FramSendByte ( BYTE AData )
{
 BYTE j;

 for (j=0; j<8; j++)
  {
   if (AData&0x80) FramDataHigh;
   else FramDataLow;
   FramSckLow;
   FramSckHigh;
   AData<<=1;
  }
}

BYTE FramRecvByte ( void )
{
 BYTE j;
 BYTE BResult;

 BResult=0;
 for (j=0; j<8; j++)
  {
   FramSckLow;
   BResult=(BResult<<1)|FramGetData;
   FramSckHigh;
  }

 return BResult;
}

void FramInit ( void )
{
 FramCsLow;
 FramSendByte(0x01);
 FramSendByte(0x00);
 FramCsHigh;
}

void FramWrStart ( WORD AAddress )
{
 FramCsLow;
 FramSendByte(0x06);
 FramCsHigh;

 FramCsLow;
 FramSendByte(0x02);
 FramSendByte(AAddress>>8); FramSendByte(AAddress);
}

void FramWrNextB ( BYTE AData )
{
 FramSendByte(AData);
}

void FramWrNextW ( WORD AData )
{
 FramSendByte(AData);
 FramSendByte(AData>>8);
}

void FramWrNext8 ( BYTE *AData )
{
 BYTE j;

 for (j=0; j<8; j++) FramSendByte(AData[j]);
}

void FramWrStop ( void )
{
 FramCsHigh;
}

void FramRdStart ( WORD AAddress )
{
 FramCsLow;
 FramSendByte(0x03);
 FramSendByte(AAddress>>8); FramSendByte(AAddress);
}

BYTE FramRdNextB ( void )
{
 return FramRecvByte();
}

WORD FramRdNextW ( void )
{
 WORD BResult;

 BResult= (WORD)FramRecvByte()|
         ((WORD)FramRecvByte()<<8);

 return BResult;
}

void FramRdNext8 ( BYTE *AData )
{
 BYTE j;

 for (j=0; j<8; j++) AData[j]=FramRecvByte();
}

void FramRdStop ( void )
{
 FramCsHigh;
}


