#include "Defs.h"
#include "HwDefs.h"
#include "ErrorCodes.h"
#include "Crt.h"

void MlxWrReg ( BYTE AIndex, BYTE AData )
{
 BYTE i, j;

 TrbWrite;
 ModeConf;
 for (i=0; i<4; i++)
  {
   if (AIndex&0x08) DataHigh; else DataLow;
   SclkHigh;
   AIndex<<=1;
   SclkHigh;
   SclkHigh;
   SclkLow;
  }

 for (i=0; i<8; i++)
  {
   if (AData&0x80) DataHigh; else DataLow;
   SclkHigh;
   AData<<=1;
   SclkHigh;
   SclkHigh;
   SclkLow;
  }

 for (j=0; j<100; j++);
 DataHigh;
 ModeComm;
}

BYTE MlxWaitDSYN ( void )
{
 BYTE BResult;

 BResult=TRUE;
 TimerReset;
 while (DSYN) if (TimerTest) { BResult=FALSE; break; }
 while (DSYN==0) if (TimerTest) { BResult=FALSE; break; }

 return BResult;
}

void MlxSendStart ( BYTE ATimerFlags, BYTE ATimerCmp, BYTE ASymbol )
{
 BYTE BClkIndex;

 DataHigh;
 ModeComm;
 TrbWrite;

 TimerSet(ATimerFlags,ATimerCmp);

 for (BClkIndex=0; BClkIndex<3; BClkIndex++)
  {
   if (ASymbol&0x04) DataHigh;
   else DataLow;
   SclkHigh;
   ASymbol<<=1;
   SclkLow;
  }
}

BYTE MlxSendStop ( BYTE ATimerFlags, BYTE ATimerCmp )
{
 BYTE BResult;

 BResult=ENoError;
 do
  {
   if (MlxWaitDSYN()==FALSE) { BResult=ENoDSYN; break; }
   if (MlxWaitDSYN()==FALSE) { BResult=ENoDSYN; break; }
  } while(0);

 TimerSet(ATimerFlags,ATimerCmp);

 return BResult;
}

BYTE MlxSyncStartASK ( BYTE ATimerFlags, BYTE ATimerCmp )
{
 BYTE BResult;

 BResult=FALSE;
 TimerSet(ATimerFlags,ATimerCmp);
 while (TimerTest==0)
  {
   if (GetData)
    {
     if ((GetData)&&(GetData)) { SclkHigh; BResult=TRUE; break; }
    }
  }

 return BResult;
}

void MlxSyncStop ( void )
{
 SclkLow;
 TimerStop();
}

BYTE MlxSendNextSym3P ( BYTE ASymbol )
{
 BYTE BResult;
 BYTE BClkIndex;

 BResult=ENoError;
 do
  {
   if (MlxWaitDSYN()==FALSE) { BResult=ENoDSYN; break; }

   for (BClkIndex=0; BClkIndex<3; BClkIndex++)
    {
     if (ASymbol&0x04) DataHigh;
     else DataLow;
     SclkHigh;
     ASymbol<<=1;
     SclkLow;
    }
  } while(0);

 return BResult;
}

BYTE MlxSendNextSym2P ( BYTE ASymbol )
{
 BYTE BResult;
 BYTE BClkIndex;

 BResult=ENoError;
 do
  {
   if (MlxWaitDSYN()==FALSE) { BResult=ENoDSYN; break; }

   for (BClkIndex=0; BClkIndex<2; BClkIndex++)
    {
     if (ASymbol&0x02) DataHigh;
     else DataLow;
     SclkHigh;
     ASymbol<<=1;
     SclkLow;
    }
  } while(0);

 return BResult;
}

BYTE MlxSendNextSym1P ( BYTE ASymbol )
{
 BYTE BResult;

 BResult=ENoError;
 do
  {
   if (MlxWaitDSYN()==FALSE) { BResult=ENoDSYN; break; }

   if (ASymbol&0x01) DataHigh;
   else DataLow;
   SclkHigh;
   SclkHigh;
   SclkHigh;
   SclkLow;
  } while(0);

 return BResult;
}

