#include "Defs.h"
#include "IsoXSize.h"

BYTE FTagRecvBuf[CTagRecvBufSize];

WORD IsoGetCrc ( BYTE *AData, BYTE ASize, WORD APolynom )
{
 WORD BCrc;
 BYTE i, j;

 BCrc=0xFFFF;
 for (i=0; i<ASize; i++)
  {
   BCrc^=AData[i];
   for (j=0; j<8; j++)
    {
     if ((BCrc & 0x0001)==0) BCrc>>=1;
     else BCrc=(BCrc>>1)^APolynom;
    }
  }
 return (BCrc);
}

WORD Iso14AGetCrcByte ( BYTE AData, WORD *ACrc)
{
 AData=(AData^(BYTE)((*ACrc) & 0x00FF));
 AData=(AData^(AData<<4));
 *ACrc=(*ACrc >> 8)^((WORD)AData << 8)^((WORD)AData<<3)^((WORD)AData>>4);

 return(*ACrc);
}

WORD Iso14AGetCrc ( BYTE *ABuf, BYTE ASize )
{
 BYTE BData;
 WORD BCrc;

 BCrc=0x6363; /* ITU-V.41 */

 while (ASize)
  {
   BData=*ABuf;
   ABuf++;
   Iso14AGetCrcByte(BData,&BCrc);
   ASize--;
  }

 return BCrc;
}


